/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package wstestbeans;


import org.glassfish.websockets.api.annotations.*;
import org.glassfish.websockets.api.*;


    @WebSocket(
        path="/hellodeployhello"    
    )
/**
 *
 * @author dannycoward
 */
public class HelloDeployHello {
    @WebSocketMessage(
            requireremote=true)
        public String onMessage(String path, Peer p) {
            String myPath = p.getContext().getPath();
            String pathToDeploy = myPath + path;
            System.out.println("Deploying new end point to: " + pathToDeploy);
            WSEndpoint endpoint = new CustomEndpoint();
            ContainerContext containerContext = p.getContext().getContainerContext();
            containerContext.deploy(endpoint, pathToDeploy);
            return "Deployed to : " + pathToDeploy;
        }
}

class CustomEndpoint implements WSEndpoint {
    public void initialize(EndpointContext epcontext){
        System.out.println("Initializing dynamically deployed end point");
    }
            /** Called whenever a peer first connects to this end point.*/
    public void onOpen(Peer p) {
        System.out.println("Opened dynamically deployed end point");
    }
    /** Called when a peer sends a text message to this end point.*/
    public void onMessage(Peer p, String message) {
        System.out.println("dynamically deployed end point got message " + message);
        try {
            p.sendMessage("PASS: Thanks for your message: " + message);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    /** Called when a peer sends a binary message to this end point.*/
    public void onMessage(Peer p, byte[] data) {
        
    }
    /** Called when a peer disconnects from this end point.*/
    public void onClose(Peer p, CloseEvent ce) {
        System.out.println("Closing dynamically deployed end point");
    }
    /** Called when there us an error on the connection from the supplied peer 
     * to this end point.
     * @param p
     * @param e 
     */
    public void onError(Peer p, Exception e) {
        System.out.println("Error");
    }
    /** Called by the container when this end point is about to be taken out of 
     * service.
     */
    public void remove() {
        System.out.println("Removed dynamically deployed end point");
    }
    
}
